> For the complete documentation index, see [llms.txt](https://docs.pagsmile.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pagsmile.com/reference/payin/submit-a-payin/brazil/wallet.md).

# Wallet

## Payin by Wallet

<mark style="color:green;">`POST`</mark> `https://gateway-test.pagsmile.com/trade/pay`

This endpoint allows you to submit a payin by Wallet in Brazil.

#### Headers

| Name                                            | Type   | Description                                |
| ----------------------------------------------- | ------ | ------------------------------------------ |
| Content-Type<mark style="color:red;">\*</mark>  | string | application/json; chartset=UTF-8           |
| Authorization<mark style="color:red;">\*</mark> | string | Basic Base($app\_*id:$security\_*&#x6B;ey) |

#### Request Body

| Name                                                       | Type   | Description                                                                                                |
| ---------------------------------------------------------- | ------ | ---------------------------------------------------------------------------------------------------------- |
| app\_id<mark style="color:red;">\*</mark>                  | string | <p>created app's id at dashboard</p><p>- Max. 32 chars -</p>                                               |
| customer.phone                                             | string | User's phone                                                                                               |
| customer.email                                             | string | User's email                                                                                               |
| customer.identify.number<mark style="color:red;">\*</mark> | string | <p>User's identification number</p><p>- 11 digits if CPF or 14 digits if CNPJ -</p>                        |
| method<mark style="color:red;">\*</mark>                   | string | Fixed value: Wallet                                                                                        |
| out\_trade\_no<mark style="color:red;">\*</mark>           | string | <p>ID given by the merchant in their system<br>- Max. 64 chars -</p>                                       |
| notify\_url<mark style="color:red;">\*</mark>              | string | Where Pagsmile will send notification to                                                                   |
| customer.identify.type<mark style="color:red;">\*</mark>   | string | <p>User's identification type</p><p>- CPF or CNPJ -</p>                                                    |
| customer.name<mark style="color:red;">\*</mark>            | string | User's name                                                                                                |
| timestamp<mark style="color:red;">\*</mark>                | string | <p>yyyy-MM-dd HH:mm:ss<br>- Max. 19 chars -</p>                                                            |
| subject<mark style="color:red;">\*</mark>                  | string | <p>payment reason or item title</p><p>- Max. 128 chars -</p>                                               |
| order\_amount<mark style="color:red;">\*</mark>            | string | <p>payment amount<br>- check <a href="/pages/10VkYvTgs08fLkqQnrUC#brazil">here</a> for limits -</p>        |
| order\_currency<mark style="color:red;">\*</mark>          | string | Fixed value: BRL                                                                                           |
| content<mark style="color:red;">\*</mark>                  | string | <p>payment reason detail or item detail. This will be shown on the bank bill.</p><p>- Max. 255 chars -</p> |
| buyer\_id<mark style="color:red;">\*</mark>                | string | merchant user's id                                                                                         |
| address.zip\_code                                          | string | zip code                                                                                                   |
| website\_url                                               | string | <p>merchant website URL</p><p>- Max. 128 chars -</p>                                                       |
| address.street                                             | string | street                                                                                                     |
| address.street\_number                                     | string | street number                                                                                              |
| address.city                                               | string | city                                                                                                       |
| address.state                                              | string | state                                                                                                      |
| return\_url                                                | string | Redirect to Merchant's url when user finished checkout                                                     |
| channel<mark style="color:red;">\*</mark>                  | string | <p>Wallet type<br>- <del>Mercadopago</del>, or PicPay -</p>                                                |

{% tabs %}
{% tab title="200 submit successfully" %}
{% tabs %}
{% tab title="PicPay" %}

```
{
    "code": "10000",
    "msg": "Success",
    "trade_no": "2022010110293900083",
    "out_trade_no": "202201010354002",
    "web_url": "",
    "trade_status": "PROCESSING",
    "wallet_url": "https://app.picpay.com/checkout/NjIxOGE4ZDc3MzY5MDQ0MGU2MDRiNGM5" //If the user use mobile, wallet_url will redirect the user to Picpay app. 
}
```

{% endtab %}

{% tab title="Mercadopago" %}

```
{
    "code": "10000",
    "msg": "Success",
    "trade_no": "2022010110293900083",
    "out_trade_no": "202201010354002",
    "web_url": "",
    "trade_status": "PROCESSING",
    "wallet_url": "https://www.mercadopago.com.br/checkout/v1/redirect?pref_id=" //If the user use mobile, wallet_url will redirect the user to Mercadopago app. 
}
```

{% endtab %}
{% endtabs %}
{% endtab %}

{% tab title="400 duplicate out\_trade\_no" %}

```
{
    "code": "40002",
    "msg": "Business Failed",
    "sub_code": "duplicate-out_trade_no",
    "sub_msg": "out_trade_no is duplicate"
}
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
**User payment tips**

* **wallet\_url** will need to be used to redirect users to the wallet page. Users will finish payment on the wallet page.
* **wallet\_url** of **Picpay** can only be opened in Brazil.
  {% endhint %}

## Example

<pre><code>curl --location --request POST 'https://gateway-test.pagsmile.com/trade/pay' \
--header 'Authorization: Basic MTYyNTgyOTIxNDUzMTY2Mzg6UGFnc21pbGVfc2tfZDUwMWQ1ZGNkNTI5OGQ5N2MwNmUzYjI4YjA2OWZjZmY3NDU5ZjY2NzNiMjFjMTFlYTY3NDM5MDgzOTZkOTYxNQ==' \
--header 'Content-Type: application/json' \
--data-raw '{
    * "app_id": "162************38",
    * "out_trade_no": "202201010354003",
    * "method": "Wallet",
    * "channel": "PicPay",
    * "order_amount": "12.01",
    * "order_currency": "BRL",
    * "subject": "trade pay test",
    * "content": "trade pay test conent",
    * "notify_url": "http://merchant/callback/success",
      "return_url": "https://www.merchant.com",
    * "buyer_id": "buyer_0101_0001",
    * "timestamp": "2022-01-01 03:54:01",
      "timeout_express":"1c",
    * "customer" : {
    *     "identify": {
    *         "type": "CPF",
    *         "number": "11032341882"
          },
    *     "name": "Test User Name",
    *     "email": "test@pagsmile.com"
      }
<strong>      }'
</strong></code></pre>

{% hint style="info" %}
Note: **162\*\*\*\*\*\*\*\*\*\*\*\*38** is pagsmile's test app id for sandbox, and **MTYyNTgyOTIxNDUzMTY2Mzg6UGFnc21pbGVfc2tfZDUwMWQ1ZGNkNTI5OGQ5N2MwNmUzYjI4YjA2OWZjZmY3NDU5ZjY2NzNiMjFjMTFlYTY3NDM5MDgzOTZkOTYxNQ==** is authorization token associated with the test app id.
{% endhint %}

{% hint style="danger" %}
Please use your own **app\_id** and generate your own **authorization token** when testing.
{% endhint %}

## Third-party CPF/CNPJ Validator

* <mark style="color:blue;">**Go:**</mark> [<mark style="color:blue;">https://github.com/paemuri/brdoc</mark>](https://github.com/paemuri/brdoc)
* <mark style="color:blue;">**JavaScript:**</mark> <https://www.npmjs.com/package/cpf-cnpj-validator>
* <mark style="color:blue;">**Online:**</mark> [<mark style="color:blue;">https://4app.net/tools/validator/document/cpf\_validator</mark>](https://4app.net/tools/validator/document/cpf_validator)
